
function level1(contid, objprop, title, refreshtime, measure){        
  this.title = title;
  this.measure = measure;
  this.min = -20;
  this.max = 35;
  
  this.title_font = 'bold 16px Tahoma';
  this.value_font = 'bold 10px Tahoma';
  this.mark_font = 'bold 10px Tahoma';
  this.border = 'silver';
  this.textcolor = 'silver';
  this.color = 'white';
  this.alertcolor = 'red';
  this.color2 = 'rgba(120,120,120,1)';
  this.valuemincolor = 'blue';
  this.valuemaxcolor = 'red';
  this.valuecolor 	 = 'green';  
  this.background = 'rgba(100,160,230,1)';
  this.marker_textcolor = 'silver';
  this.marker_font = 'bold 12px Tahoma';
  
  if (this.measure == '') {
    this.measure = '°';
  }  
  
  this.contid = contid;
  this.objprop = objprop;
  this.refreshtime = refreshtime;
  
  this.redraw = function(){   
	if (!this.context) {
		return;
	}  
	  
    // Value
	this.context.clearRect(0, 0, 100, 200);

    // border
    this.context.fillStyle = this.border;
	this.context.fillRoundedRect(25, 2, 50, 168, 10);
	
	// Rect
	var rHeight = 156;
	
    this.context.fillStyle = this.color;
    this.context.fillRect(30, 8, 40, rHeight);
	
	if (this.drawmarker) {
	  this.drawmarker();
	  
	  this.context.fillStyle = this.textcolor;  
	  this.context.font = this.marker_font;	  
	  this.context.fillText( this.GetDirection(), 10, 22); 
	}
	
	this.context.textAlign = "center";

	// Title	
    this.context.font = this.title_font;
	this.context.fillStyle = this.textcolor;
    this.context.fillText(this.title, 50, 190, 90); 
	
    // Value  	
    if (this.value != ''){     
      this.elem.title =  this.valupdated;
	  
	  //  y    n-min
	  //  - = -------    -> ( n-min )*h/(max-min)
	  //  H    max-min
	  
	  var ylevel = rHeight-((this.value-this.min)*rHeight/(this.max-this.min));
      if (ylevel < 0) ylevel = 0;
	  if (ylevel > rHeight) ylevel = rHeight;
	  
	  // Level
	  this.context.fillStyle = this.valuecolor;
      this.context.fillRect(30, 8+ylevel, 40, (rHeight-ylevel));	  
	  
	  // Value	  
	  if ((this.alertstate != 0) && (this.alertframe == 0) ) {
	    this.context.fillStyle = this.alertcolor;
	  } else {
	    this.context.fillStyle = this.color;
	  }
	  this.context.font = this.value_font;	 
	  this.context.fillText(this.value+this.measure, 50, 8+ylevel+((rHeight-ylevel)/2), 45);	  
    }
	
	this.context.font = this.mark_font;
	this.context.fillStyle = this.textcolor;
	this.context.textAlign = "start";
	
	// Skal
	var y = 166;
	var ly = 166;
	var step = (166-12) / (this.max - this.min); 
	for (var n=this.min;n<this.max;n++)	{
	  if (y < ly-this.textHeight){
	    this.context.fillText(n, 80, y, 90);	
		ly = y;		
	  }
	  y = y - step; 
	}	
	
	// Max
	this.context.fillStyle = this.valuemaxcolor;
	this.context.fillText(this.max, 80, 12, 90);
	
	// Min
	this.context.fillStyle = this.valuemincolor;
	this.context.fillText(this.min, 80, 166, 90);
  } 
  
  this.drawmarker = function(){
	if (!this.context) {
		return;
	}  
	  
    if (this.eventState == ''){
	  this.context.fillStyle = 'green';
	} else {
  	  if (this.eventState == 'processing'){
	    this.context.fillStyle = 'black';
	  } else {
	    this.context.fillStyle = 'yellow';          
	  }
	}
	
	this.context.font = this.marker_font;
	this.context.textAlign = "left";  
    this.context.fillText('•', 10, 12); 
  }  
  
  this.init( );
  
  this.context.font = this.title_font;
  this.textHeight = this.context.measureText('|').width *1.2;
}

level1.prototype = new s2_alertobject();