CanvasRenderingContext2D.prototype.fillRoundedRect = fillRoundedRect;

function fillRoundedRect(x, y, w, h, r){
 this.beginPath();
 this.moveTo(x+r, y);
 this.lineTo(x+w-r, y);
 this.quadraticCurveTo(x+w, y, x+w, y+r);
 this.lineTo(x+w, y+h-r);
 this.quadraticCurveTo(x+w, y+h, x+w-r, y+h);
 this.lineTo(x+r, y+h);
 this.quadraticCurveTo(x, y+h, x, y+h-r);
 this.lineTo(x, y+r);
 this.quadraticCurveTo(x, y, x+r, y);
 this.fill();
}

function s2_object(){
  this.contid = '';    
  this.objprop = '';
  
  this.refreshtime = 5*60*1000; // 5 min
  this.eventState = '';
  this.eventTimer = '';  
  this.drawmarker = true;
  this.value = '';
  this.lastvalue = '';
  this.valupdated = '';
  
  this.init = function( ){        
	
	this.elem = document.getElementById( this.contid );
	if (!this.elem || !this.elem.getContext) {	  
	  return;
	}  
	
	// Get the canvas 2d context.
	this.context = this.elem.getContext('2d');
	if (!this.context) {
		return;
	}  
	
	this.redraw();  
    this.NextEvent( this );   
  }
  
  this.redraw = function(){    
	if (!this.context) {
		return;
	}  
	  
    // Rect
    this.context.fillStyle = 'red';
    this.context.fillRect(0, 0, this.elem.width, this.elem.height);

	if (this.drawmarker) this.drawmarker();
  }
  
  this.drawmarker = function(){
  }
  
  this.GetDirection = function(){
	var mark = '';
	
	if ((this.value != '') && (this.lastvalue != '')){
	  if (this.value > this.lastvalue){
	    mark = '▲';
	  } else {
	    if (this.value < this.lastvalue){
  	      mark = '▼';
	    }
	  }
	}

    return mark; 	  
  }
  
  this.NextEventReceived = function(fobj, data) {  
	this.eventState = 'processing';	

    var d=data.split('|');
	if (d[0] == '') return false;
	
	this.lastvalue = this.value;
    this.value = Number(d[0]).toFixed(2);
    this.valupdated = d[1];  

	this.eventState = '';		
	this.UpdateData(fobj);
	
	this.redraw();		
	
	return false;	
  }
  
  this.UpdateData = function(fobj){    
  }
  
  this.NextEvent = function(fobj) {                
	// Set next timer
    clearTimeout(fobj.eventTimer);
    fobj.eventTimer = window.setTimeout( function() { 	  
	  fobj.NextEvent( fobj ); 
	}, fobj.refreshtime);
	
    fobj.eventState='requesting';  		
	if (this.drawmarker) fobj.drawmarker();

	// Req data
	var xmlhttp=false;
	if (!xmlhttp && typeof XMLHttpRequest!='undefined') {
	  xmlhttp = new XMLHttpRequest();
	}
	xmlhttp.open("GET", '/s2/getdata.php?p='+fobj.objprop, true);
	xmlhttp.onreadystatechange=function() {
	  if (xmlhttp.readyState==4) {
		fobj.NextEventReceived( fobj, xmlhttp.responseText );
	  }
	}
	xmlhttp.send(null);

    return false;
  }  
}

function s2_alertobject(contid, objprop, title, refreshtime, measure){        
  this.alertmin = -20;
  this.alertmax = 40;
  this.alertTimer = '';
  this.alerttime = 500; // 0.5 sek  
  this.alertstate = 0;  // 0 - off, 1 - on
  this.alertframe = 0;  // Animate frame: 0 - norm, 1 - red

  this.UpdateData = function(fobj){
    clearTimeout(fobj.alertTimer);
	
	// Range
	fobj.alertstate = (fobj.value < fobj.alertmin) || (fobj.value > fobj.alertmax);
	
	if (fobj.alertstate != 0){
      fobj.alertTimer = window.setTimeout( function() { 	  
	    fobj.NextAlert( fobj ); 
	  }, fobj.alerttime);
	}
	
	fobj.redraw();
  }  

  this.NextAlert = function(fobj) {                
	clearTimeout(fobj.alertTimer);
	
	fobj.alertTimer = window.setTimeout( function() { 	  
	  fobj.NextAlert( fobj ); 
	}, fobj.alerttime);

	fobj.NextAlertFrame(fobj);
	fobj.redraw();
  }

  this.NextAlertFrame = function(fobj){
    if (fobj.alertstate == 0) { 
	  fobj.alertstate = 1;
	} else {
	  fobj.alertstate = 0;
	}
  }
	
}

s2_alertobject.prototype = new s2_object();